
varying vec4 col;
void main(){
	float f;
	
	/* calcola la normale nel frame di vista */
	vec4 norm = vec4(normalize(gl_NormalMatrix * gl_Normal),0.0);
	
	/* calcola la posizione del vertice nel frame di vista */
	vec4 viewv =  gl_ModelViewMatrix * gl_Vertex;
	
	/* calcola la direzione dal vertice verso la luce GL_LIGHT0 */
 	vec4 lightv = normalize(gl_LightSource[0].position - gl_ModelViewMatrix * gl_Vertex);

	/* calcola l'half-way vector */
	vec4 halfv = normalize(lightv + norm);

	/* se   back facing non c'e' contributo */	
	if(dot (lightv,norm) >0.0) f = 1.0; else f = 0.0;
	
	/* calcola la componente diffusa */
	vec4 diffuse = max ( 0.0, dot(lightv,norm)) * gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;

	/* calcola la componente ambiente */
	vec4 ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;

	/* calcola la componente speculare */
	vec4 specular =  gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(max(0.0,dot(norm,halfv)),gl_FrontMaterial.shininess);

	/* calcola il colore finale sul vertice */
	vec3 color = vec3(ambient + diffuse + specular)*f;
	
	/* assegna il colore alla variabile varying che sara' interpolata nei frammenti */
	col =  vec4(color,1.0);

	gl_Position = gl_ModelViewProjectionMatrix*gl_Vertex;

}
